using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.IO.Ports;

namespace ArduinoAccerelo
{
    public partial class Form1 : Form
    {
        Thread t;
        int x = 512, y = 512, z = 512; // only access with lock(this)

        public Form1()
        {
            InitializeComponent();
            t = new Thread(read);
            t.Start();
        }

        protected override void OnClosing(CancelEventArgs e)
        {
            t.Abort();

            base.OnClosing(e);
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
            lock (this)
            {
                e.Graphics.DrawLine(Pens.Black, 20, 200, 20, 200 - 100.0f * (x - 512) / 100.0f);
                e.Graphics.DrawLine(Pens.Black, 40, 200, 40, 200 - 100.0f * (y - 512) / 100.0f);
                e.Graphics.DrawLine(Pens.Black, 60, 200, 60, 200 - 100.0f * (z - 512) / 100.0f);
            }
        }

        private void read()
        {
            SerialPort sp = new SerialPort("COM2", 9600);
            sp.Open();
            try
            {
                sp.DiscardInBuffer();
                while (true)
                {
                    string s = sp.ReadLine();
                    string[] s1 = s.Split(':');
                    lock (this)
                    {
                        x = Int32.Parse(s1[0]);
                        y = Int32.Parse(s1[1]);
                        z = Int32.Parse(s1[2]);
                    }
                    Invalidate();
                }
            }
            finally
            {
                sp.Close();
            }
        }
    }
}